package cn.iocoder.yudao.module.pms.service.yanfan.media;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.module.pms.controller.admin.yanfan.media.vo.YfMediaServerPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.yanfan.media.vo.YfMediaServerSaveReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.yanfan.sip.device.vo.YfSipDeviceRespVO;
import cn.iocoder.yudao.module.pms.controller.admin.yanfan.sip.vo.VideoSessionInfo;
import cn.iocoder.yudao.module.pms.dal.dataobject.yanfan.media.YfMediaServerDO;
import cn.iocoder.yudao.module.pms.dal.dataobject.yanfan.sip.config.IotSipConfigDO;
import cn.iocoder.yudao.module.pms.dal.dataobject.yanfan.sip.device.YfSipDeviceDO;
import com.alibaba.fastjson.JSONObject;
import liquibase.pro.packaged.Y;

import javax.validation.Valid;

/**
 * yf流媒体服务器配置 Service 接口
 *
 * @author 超级管理员
 */
public interface YfMediaServerService {
    JSONObject listRtpServer();
    int deleteMediaServerByIds(Long[] ids);
    List<YfMediaServerDO> selectMediaServer();
    int updateMediaServer(YfMediaServerSaveReqVO mediaServer);
    YfMediaServerDO checkMediaServer(String ip, Long port, String secret);
    VideoSessionInfo createRTPServer(IotSipConfigDO sipConfig, YfMediaServerDO mediaInfo, YfSipDeviceRespVO device, VideoSessionInfo videoSessionInfo);
    YfMediaServerDO selectMediaServerBytenantId(Long tenantId);
    YfMediaServerDO selectMediaServerBydeviceSipId(String deviceSipId);
    /**
     * 创建yf流媒体服务器配置
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Integer createYfMediaServer(@Valid YfMediaServerSaveReqVO createReqVO);

    /**
     * 更新yf流媒体服务器配置
     *
     * @param updateReqVO 更新信息
     */
    void updateYfMediaServer(@Valid YfMediaServerSaveReqVO updateReqVO);

    /**
     * 删除yf流媒体服务器配置
     *
     * @param id 编号
     */
    void deleteYfMediaServer(Long id);

    /**
     * 获得yf流媒体服务器配置
     *
     * @param id 编号
     * @return yf流媒体服务器配置
     */
    YfMediaServerDO getYfMediaServer(Long id);

    /**
     * 获得yf流媒体服务器配置分页
     *
     * @param pageReqVO 分页查询
     * @return yf流媒体服务器配置分页
     */
    PageResult<YfMediaServerDO> getYfMediaServerPage(YfMediaServerPageReqVO pageReqVO);


    boolean syncMediaServer(YfMediaServerDO mediaServer,String secret);
}
